<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::mediaPlayer::PipelineInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1media_player.html">mediaPlayer</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html">PipelineInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::mediaPlayer::PipelineInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_pipeline_interface_8h_source.html">PipelineInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::mediaPlayer::PipelineInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1media_player_1_1_pipeline_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1media_player_1_1_pipeline_interface_inherit__map" id="alexa_client_s_d_k_1_1media_player_1_1_pipeline_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html" title="alexaClientSDK::mediaPlayer\l::MediaPlayer" alt="" coords="5,92,202,131"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab03a69c41562d2ec870b0702391bda3c"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#ab03a69c41562d2ec870b0702391bda3c">setAppSrc</a> (GstAppSrc *appSrc)=0</td></tr>
<tr class="separator:ab03a69c41562d2ec870b0702391bda3c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9ef094b2a6f10214467c1dd27abe2918"><td class="memItemLeft" align="right" valign="top">virtual GstAppSrc *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a9ef094b2a6f10214467c1dd27abe2918">getAppSrc</a> () const =0</td></tr>
<tr class="separator:a9ef094b2a6f10214467c1dd27abe2918"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16c058802b632a9b0f1b0bfc8a369e4d"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a16c058802b632a9b0f1b0bfc8a369e4d">setDecoder</a> (GstElement *decoder)=0</td></tr>
<tr class="separator:a16c058802b632a9b0f1b0bfc8a369e4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0103c2aeb1c68c3a7cf6e6adc6634f76"><td class="memItemLeft" align="right" valign="top">virtual GstElement *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a0103c2aeb1c68c3a7cf6e6adc6634f76">getDecoder</a> () const =0</td></tr>
<tr class="separator:a0103c2aeb1c68c3a7cf6e6adc6634f76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ef4f189af48cba70ec1cbdb2eb730ae"><td class="memItemLeft" align="right" valign="top">virtual GstElement *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a3ef4f189af48cba70ec1cbdb2eb730ae">getPipeline</a> () const =0</td></tr>
<tr class="separator:a3ef4f189af48cba70ec1cbdb2eb730ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22d94edce4ea73a296090549f952855b"><td class="memItemLeft" align="right" valign="top">virtual guint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a22d94edce4ea73a296090549f952855b">queueCallback</a> (const std::function&lt; gboolean()&gt; *callback)=0</td></tr>
<tr class="separator:a22d94edce4ea73a296090549f952855b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45d5a819757a0b40866d7f882fa36f4f"><td class="memItemLeft" align="right" valign="top">virtual guint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a45d5a819757a0b40866d7f882fa36f4f">attachSource</a> (GSource *source)=0</td></tr>
<tr class="separator:a45d5a819757a0b40866d7f882fa36f4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4939ae107f03be058eabe02931f807d"><td class="memItemLeft" align="right" valign="top">virtual gboolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#ad4939ae107f03be058eabe02931f807d">removeSource</a> (guint tag)=0</td></tr>
<tr class="separator:ad4939ae107f03be058eabe02931f807d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a23e24d2aa6c2eddb32753a09a44fdc2c"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html#a23e24d2aa6c2eddb32753a09a44fdc2c">~PipelineInterface</a> ()=default</td></tr>
<tr class="separator:a23e24d2aa6c2eddb32753a09a44fdc2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">An interface that allows accessing some members of an <code>AudioPipeline</code> instantiated by the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">MediaPlayer</a></code>. The interface also allows queuing callbacks on the worker thread of the <code><a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">MediaPlayer</a></code>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a23e24d2aa6c2eddb32753a09a44fdc2c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a23e24d2aa6c2eddb32753a09a44fdc2c">&#9670;&nbsp;</a></span>~PipelineInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::mediaPlayer::PipelineInterface::~PipelineInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a45d5a819757a0b40866d7f882fa36f4f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a45d5a819757a0b40866d7f882fa36f4f">&#9670;&nbsp;</a></span>attachSource()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual guint alexaClientSDK::mediaPlayer::PipelineInterface::attachSource </td>
          <td>(</td>
          <td class="paramtype">GSource *&#160;</td>
          <td class="paramname"><em>source</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Attach the source to the worker thread.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>The source to be executed on the worker thread. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The ID (greater than 0) of the source. 0 if there is an error. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a4ea8c20e31d8fb4d9c74e009ab9f74a2">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="a9ef094b2a6f10214467c1dd27abe2918"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9ef094b2a6f10214467c1dd27abe2918">&#9670;&nbsp;</a></span>getAppSrc()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual GstAppSrc* alexaClientSDK::mediaPlayer::PipelineInterface::getAppSrc </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the appSrc element of the <code>AudioPipeline</code>.</p>
<dl class="section return"><dt>Returns</dt><dd>The appSrc element. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ae36f33caf12c633b936a3b5a2f054adb">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="a0103c2aeb1c68c3a7cf6e6adc6634f76"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0103c2aeb1c68c3a7cf6e6adc6634f76">&#9670;&nbsp;</a></span>getDecoder()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual GstElement* alexaClientSDK::mediaPlayer::PipelineInterface::getDecoder </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the decoder element of the <code>AudioPipeline</code>.</p>
<dl class="section return"><dt>Returns</dt><dd>The decoder element. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ab6b5f8f2a0cb22299a20de4bfb1d8e11">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="a3ef4f189af48cba70ec1cbdb2eb730ae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ef4f189af48cba70ec1cbdb2eb730ae">&#9670;&nbsp;</a></span>getPipeline()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual GstElement* alexaClientSDK::mediaPlayer::PipelineInterface::getPipeline </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the pipeline of the <code>AudioPipeline</code>.</p>
<dl class="section return"><dt>Returns</dt><dd>The pipeline. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a349de9f04e24a208f65357d3ce32ef22">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="a22d94edce4ea73a296090549f952855b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a22d94edce4ea73a296090549f952855b">&#9670;&nbsp;</a></span>queueCallback()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual guint alexaClientSDK::mediaPlayer::PipelineInterface::queueCallback </td>
          <td>(</td>
          <td class="paramtype">const std::function&lt; gboolean()&gt; *&#160;</td>
          <td class="paramname"><em>callback</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Queue the specified callback for execution on the worker thread.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">callback</td><td>The callback to queue. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The ID of the queued callback (for calling <code>g_source_remove</code>). </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a49bda1306d465d81023f9743e1350f62">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="ad4939ae107f03be058eabe02931f807d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad4939ae107f03be058eabe02931f807d">&#9670;&nbsp;</a></span>removeSource()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual gboolean alexaClientSDK::mediaPlayer::PipelineInterface::removeSource </td>
          <td>(</td>
          <td class="paramtype">guint&#160;</td>
          <td class="paramname"><em>tag</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Remove the callback from the worker thread.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>ID of the queued callback. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the removal is successful. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aae0be228bf3888f89759296cb4329ecb">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="ab03a69c41562d2ec870b0702391bda3c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab03a69c41562d2ec870b0702391bda3c">&#9670;&nbsp;</a></span>setAppSrc()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::mediaPlayer::PipelineInterface::setAppSrc </td>
          <td>(</td>
          <td class="paramtype">GstAppSrc *&#160;</td>
          <td class="paramname"><em>appSrc</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Sets the appSrc element in the <code>AudioPipeline</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">appSrc</td><td>The element the appSrc of <code>AudioPipeline</code> should be set to. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a2511dfe48da19611a02b9e87e939cb7c">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<a id="a16c058802b632a9b0f1b0bfc8a369e4d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16c058802b632a9b0f1b0bfc8a369e4d">&#9670;&nbsp;</a></span>setDecoder()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::mediaPlayer::PipelineInterface::setDecoder </td>
          <td>(</td>
          <td class="paramtype">GstElement *&#160;</td>
          <td class="paramname"><em>decoder</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Sets the decoder element in the <code>AudioPipeline</code> </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">decoder</td><td>The element the decoder of <code>AudioPipeline</code> should be set to. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#af4089dee120a37c3c4f7016c647cfe26">alexaClientSDK::mediaPlayer::MediaPlayer</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/MediaPlayer/GStreamerMediaPlayer/include/MediaPlayer/<a class="el" href="_pipeline_interface_8h_source.html">PipelineInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
